--- old/./mr_sas.c	Tue Nov  6 14:29:38 2012
+++ new/./mr_sas.c	Tue Nov  6 14:29:38 2012
@@ -1072,20 +1203,21 @@
 		}
 	}
 
-	if(instance->unroll.aenPend == 1)  {
-		if (abort_aen_cmd(instance, instance->aen_cmd)) 
+	if (instance->unroll.aenPend == 1) {
+		if (abort_aen_cmd(instance, instance->aen_cmd))
 			cmn_err(CE_WARN, "mrsas_detach: "
-					"failed to abort prevous AEN command");
+			    "failed to abort prevous AEN command");
 
 		instance->unroll.aenPend = 0;
 		con_log(CL_ANN1, (CE_CONT, "aen cmd aborted, done."));
-		 /*This means the controller is fully initialzed and running */
-		 // shutdown_controller();Shutdown should be a last command to controller.
+		/* This means the controller is fully initialized and running */
+		/* Shutdown should be a last command to controller. */
+		/* shutdown_controller(); */
 	}
 
 
-	if(instance->unroll.timer == 1)	 {
-		if (instance->timeout_id != (timeout_id_t)-1)  {
+	if (instance->unroll.timer == 1)	 {
+		if (instance->timeout_id != (timeout_id_t)-1) {
 			(void) untimeout(instance->timeout_id);
 			instance->timeout_id = (timeout_id_t)-1;
 
@@ -1096,7 +1228,7 @@
 	instance->func_ptr->disable_intr(instance);
 
 
-	if(instance->unroll.mutexs == 1)  {
+	if (instance->unroll.mutexs == 1) {
 		mutex_destroy(&instance->cmd_pool_mtx);
 		mutex_destroy(&instance->app_cmd_pool_mtx);
 		mutex_destroy(&instance->cmd_pend_mtx);
@@ -1114,7 +1246,7 @@
 		}
 
 		instance->unroll.mutexs = 0;
-		con_log(CL_ANN1, (CE_CONT, "Destroy mutex & cv,  done."));
+		con_log(CL_ANN1, (CE_CONT, "Destroy mutex & cv,	 done."));
 	}
 
 
@@ -1123,13 +1255,13 @@
 		instance->unroll.soft_isr = 0;
 	}
 
-	if(instance->unroll.intr == 1)	{
+	if (instance->unroll.intr == 1) {
 		mrsas_rem_intrs(instance);
 		instance->unroll.intr = 0;
 	}
-	   
 
-	if(instance->unroll.taskq == 1)	 {
+
+	if (instance->unroll.taskq == 1)	 {
 		if (instance->taskq) {
 			ddi_taskq_destroy(instance->taskq);
 			instance->unroll.taskq = 0;
@@ -1136,27 +1268,32 @@
 		}
 
 	}
-	 
-	/*free dma memory allocated for
-	  cmds/frames/queues/driver version etc */
-	if(instance->unroll.verBuff == 1) {
-		mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
+
+	/*
+	 * free dma memory allocated for
+	 * cmds/frames/queues/driver version etc
+	 */
+	if (instance->unroll.verBuff == 1) {
+		(void) mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
 		instance->unroll.verBuff = 0;
 	}
 
-	if(instance->unroll.pdlist_buff == 1)  {
-		if (instance->mr_tbolt_pd_list != NULL) 
+	if (instance->unroll.pdlist_buff == 1)	{
+		if (instance->mr_tbolt_pd_list != NULL) {
 			kmem_free(instance->mr_tbolt_pd_list,
-				MRSAS_TBOLT_GET_PD_MAX(instance) * sizeof (struct mrsas_tbolt_pd));
+			    MRSAS_TBOLT_GET_PD_MAX(instance) *
+			    sizeof (struct mrsas_tbolt_pd));
+		}
 
 		instance->mr_tbolt_pd_list = NULL;
 		instance->unroll.pdlist_buff = 0;
 	}
 
-	if(instance->unroll.ldlist_buff == 1)  {
-		if (instance->mr_ld_list != NULL) 
+	if (instance->unroll.ldlist_buff == 1)	{
+		if (instance->mr_ld_list != NULL) {
 			kmem_free(instance->mr_ld_list, MRDRV_MAX_LD
-				* sizeof (struct mrsas_ld));
+			    * sizeof (struct mrsas_ld));
+		}
 
 		instance->mr_ld_list = NULL;
 		instance->unroll.ldlist_buff = 0;
@@ -1163,24 +1300,22 @@
 	}
 
 	if (instance->tbolt) {
-		if(instance->unroll.alloc_space_mpi2 == 1) {		
+		if (instance->unroll.alloc_space_mpi2 == 1) {
 			free_space_for_mpi2(instance);
 			instance->unroll.alloc_space_mpi2 = 0;
 		}
 	} else {
-		if(instance->unroll.alloc_space_mfi == 1) {		
+		if (instance->unroll.alloc_space_mfi == 1) {
 			free_space_for_mfi(instance);
 			instance->unroll.alloc_space_mfi = 0;
 		}
 	}
 
-	if(instance->unroll.regs == 1)  {
+	if (instance->unroll.regs == 1)	 {
 		ddi_regs_map_free(&instance->regmap_handle);
 		instance->unroll.regs = 0;
-		con_log(CL_ANN1, (CE_CONT, "ddi_regs_map_free()  done."));
+		con_log(CL_ANN1, (CE_CONT, "ddi_regs_map_free()	 done."));
 	}
-
-	return (DDI_SUCCESS);
 }
 
 
@@ -1187,9 +1322,9 @@
 
 /*
  * ************************************************************************** *
- *                                                                            *
- *             common entry points - for character driver types               *
- *                                                                            *
+ *									      *
+ *	       common entry points - for character driver types		      *
+ *									      *
  * ************************************************************************** *
  */
 /*
@@ -1203,7 +1338,7 @@
  * through the open() and close() entry points. The primary function of
  * open() is to verify that the open request is allowed.
  */
-static  int
+static	int
 mrsas_open(dev_t *dev, int openflags, int otyp, cred_t *credp)
 {
 	int	rval = 0;
@@ -1246,7 +1381,7 @@
  * close() should perform any cleanup necessary to finish using the minor
  * device, and prepare the device (and driver) to be opened again.
  */
-static  int
+static	int
 mrsas_close(dev_t dev, int openflags, int otyp, cred_t *credp)
 {
 	int	rval = 0;
@@ -1300,11 +1435,7 @@
 
 	ioctl = (struct mrsas_ioctl *)kmem_zalloc(sizeof (struct mrsas_ioctl),
 	    KM_SLEEP);
-	if (ioctl == NULL) {
-		/* Failed to allocate memory for ioctl  */
-		con_log(CL_ANN, (CE_WARN, "mr_sas_ioctl: failed to allocate memory for ioctl"));
-		return (ENXIO);
-	}
+	ASSERT(ioctl);
 
 	switch ((uint_t)cmd) {
 		case MRSAS_IOCTL_FIRMWARE:
@@ -1331,9 +1462,6 @@
 
 			break;
 		case MRSAS_IOCTL_AEN:
-			con_log(CL_ANN, (CE_NOTE,
-				    "mrsas_ioctl: IOCTL Register AEN.\n"));
-
 			if (ddi_copyin((void *) arg, &aen,
 			    sizeof (struct mrsas_aen), mode)) {
 				con_log(CL_ANN, (CE_WARN,
@@ -1366,11 +1494,12 @@
 
 /*
  * ************************************************************************** *
- *                                                                            *
- *               common entry points - for block driver types                 *
- *                                                                            *
+ *									      *
+ *		 common entry points - for block driver types		      *
+ *									      *
  * ************************************************************************** *
  */
+#ifdef __sparc
 /*
  * reset - TBD
  * @dip:
@@ -1407,10 +1536,9 @@
 
 	return (DDI_SUCCESS);
 }
-
-
+#else /* __sparc */
 /*ARGSUSED*/
-int
+static int
 mrsas_quiesce(dev_info_t *dip)
 {
 	int	instance_no;
@@ -1457,17 +1585,19 @@
 	flush_cache(instance);
 
 	if (wait_for_outstanding(instance)) {
-		con_log(CL_ANN1, (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
+		con_log(CL_ANN1,
+		    (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
 		return (DDI_FAILURE);
 	}
 	return (DDI_SUCCESS);
 }
+#endif	/* __sparc */
 
 /*
  * ************************************************************************** *
- *                                                                            *
- *                          entry points (SCSI HBA)                           *
- *                                                                            *
+ *									      *
+ *			    entry points (SCSI HBA)			      *
+ *									      *
  * ************************************************************************** *
  */
 /*
@@ -1504,7 +1634,8 @@
 		 * to be created.
 		 */
 		if ((child = mrsas_find_child(instance, tgt, lun)) != NULL) {
-			con_log(CL_DLEVEL2, (CE_NOTE, "mrsas_tgt_init find child ="
+			con_log(CL_DLEVEL2,
+			    (CE_NOTE, "mrsas_tgt_init find child ="
 			    " %p t = %d l = %d", (void *)child, tgt, lun));
 			if (ndi_merge_node(tgt_dip, mrsas_name_node) !=
 			    DDI_SUCCESS)
@@ -1532,11 +1663,11 @@
 	}
 
 #ifdef PDSUPPORT
-	else if(instance->tbolt) {
+	else if (instance->tbolt) {
 		if (instance->mr_tbolt_pd_list[tgt].dip == NULL) {
 			mutex_enter(&instance->config_dev_mtx);
 			instance->mr_tbolt_pd_list[tgt].dip = tgt_dip;
-			instance->mr_tbolt_pd_list[tgt].flag = 
+			instance->mr_tbolt_pd_list[tgt].flag =
 			    MRDRV_TGT_VALID;
 			mutex_exit(&instance->config_dev_mtx);
 			con_log(CL_ANN1, (CE_NOTE, "mrsas_tran_tgt_init:"
@@ -1570,7 +1701,7 @@
 	}
 
 #ifdef PDSUPPORT
-	else if(instance->tbolt) {
+	else if (instance->tbolt) {
 		mutex_enter(&instance->config_dev_mtx);
 		instance->mr_tbolt_pd_list[tgt].dip = NULL;
 		mutex_exit(&instance->config_dev_mtx);
@@ -1578,7 +1709,7 @@
 		    "for tgt:%x", tgt));
 	}
 #endif
-		
+
 }
 
 dev_info_t *
@@ -1749,7 +1880,7 @@
 static int
 mrsas_tran_start(struct scsi_address *ap, register struct scsi_pkt *pkt)
 {
-	uchar_t 	cmd_done = 0;
+	uchar_t		cmd_done = 0;
 
 	struct mrsas_instance	*instance = ADDR2MR(ap);
 	struct mrsas_cmd	*cmd;
@@ -1803,8 +1934,10 @@
 
 	if ((pkt->pkt_flags & FLAG_NOINTR) == 0) {
 		if (instance->fw_outstanding > instance->max_fw_cmds) {
-			cmn_err(CE_WARN, "mr_sas:Firmware BUSY, fw_outstanding(0x%X) > max_fw_cmds(0x%X)",
-					instance->fw_outstanding, instance->max_fw_cmds );
+			con_log(CL_ANN, (CE_CONT, "mr_sas:Firmware busy"));
+			DTRACE_PROBE2(start_tran_err,
+			    uint16_t, instance->fw_outstanding,
+			    uint16_t, instance->max_fw_cmds);
 			return_mfi_pkt(instance, cmd);
 			return (TRAN_BUSY);
 		}
@@ -1819,9 +1952,8 @@
 	} else {
 		struct mrsas_header *hdr = &cmd->frame->hdr;
 
+		instance->func_ptr->issue_cmd_in_poll_mode(instance, cmd);
 
-		instance->func_ptr-> issue_cmd_in_poll_mode(instance, cmd);
-
 		pkt->pkt_reason		= CMD_CMPLT;
 		pkt->pkt_statistics	= 0;
 		pkt->pkt_state |= STATE_XFERRED_DATA | STATE_GOT_STATUS;
@@ -1834,7 +1966,7 @@
 
 		case MFI_STAT_SCSI_DONE_WITH_ERROR:
 			con_log(CL_ANN, (CE_CONT,
-				"mrsas_tran_start: scsi done with error"));
+			    "mrsas_tran_start: scsi done with error"));
 			pkt->pkt_reason	= CMD_CMPLT;
 			pkt->pkt_statistics = 0;
 
@@ -1843,7 +1975,7 @@
 
 		case MFI_STAT_DEVICE_NOT_FOUND:
 			con_log(CL_ANN, (CE_CONT,
-				"mrsas_tran_start: device not found error"));
+			    "mrsas_tran_start: device not found error"));
 			pkt->pkt_reason		= CMD_DEV_GONE;
 			pkt->pkt_statistics	= STAT_DISCON;
 			break;
@@ -1852,6 +1984,9 @@
 			((struct scsi_status *)pkt->pkt_scbp)->sts_busy = 1;
 		}
 
+		(void) mrsas_common_check(instance, cmd);
+		DTRACE_PROBE2(start_nointr_done, uint8_t, hdr->cmd,
+		    uint8_t, hdr->cmd_status);
 		return_mfi_pkt(instance, cmd);
 
 		if (pkt->pkt_comp) {
@@ -1907,7 +2042,8 @@
 	con_log(CL_ANN1, (CE_NOTE, "chkpnt:%s:%d", __func__, __LINE__));
 
 	if (wait_for_outstanding(instance)) {
-		con_log(CL_ANN1, (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
+		con_log(CL_ANN1,
+		    (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
 		return (DDI_FAILURE);
 	} else {
 		return (DDI_SUCCESS);
@@ -1914,6 +2050,7 @@
 	}
 }
 
+#if 0
 /*
  * tran_bus_reset - reset the SCSI bus
  * @dip:
@@ -1938,12 +2075,14 @@
 	con_log(CL_ANN1, (CE_NOTE, "chkpnt:%s:%d", __func__, __LINE__));
 
 	if (wait_for_outstanding(instance)) {
-		con_log(CL_ANN1, (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
+		con_log(CL_ANN1,
+		    (CE_CONT, "wait_for_outstanding: return FAIL.\n"));
 		return (DDI_FAILURE);
 	} else {
 		return (DDI_SUCCESS);
 	}
 }
+#endif
 
 /*
  * tran_getcap - get one of a set of SCSA-defined capabilities
@@ -1978,8 +2117,8 @@
 			/* Limit to 256k max transfer */
 			rval = mrsas_tbolt_max_cap_maxxfer;
 		} else {
-		/* Limit to 16MB max transfer */
-		rval = mrsas_max_cap_maxxfer;
+			/* Limit to 16MB max transfer */
+			rval = mrsas_max_cap_maxxfer;
 		}
 		break;
 	case SCSI_CAP_MSG_OUT:
@@ -2220,7 +2359,6 @@
 	uint32_t	producer;
 	uint32_t	consumer;
 	uint32_t	context;
-	uint32_t	status, value;
 	int		retval;
 
 	struct mrsas_cmd	*cmd;
@@ -2249,10 +2387,20 @@
 	(void) ddi_dma_sync(instance->mfi_internal_dma_obj.dma_handle,
 	    0, 0, DDI_DMA_SYNC_FORCPU);
 
+	if (mrsas_check_dma_handle(instance->mfi_internal_dma_obj.dma_handle)
+	    != DDI_SUCCESS) {
+		mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+		con_log(CL_ANN1, (CE_WARN,
+		    "mr_sas_isr(): FMA check, returning DDI_INTR_UNCLAIMED"));
+		return (DDI_INTR_CLAIMED);
+	}
+	con_log(CL_ANN1, (CE_NOTE, "chkpnt:%s:%d", __func__, __LINE__));
+
 #ifdef OCRDEBUG
 	if (debug_consecutive_timeout_after_ocr_g == 1) {
 		con_log(CL_ANN1, (CE_NOTE,
-		"simulating consecutive timeout after ocr"));
+		    "simulating consecutive timeout after ocr"));
 		return (DDI_INTR_CLAIMED);
 	}
 #endif
@@ -2268,7 +2416,9 @@
 	con_log(CL_ANN, (CE_CONT, " producer %x consumer %x ",
 	    producer, consumer));
 	if (producer == consumer) {
-		con_log(CL_ANN, (CE_WARN, "producer ==  consumer case"));
+		con_log(CL_ANN, (CE_WARN, "producer ==	consumer case"));
+		DTRACE_PROBE2(isr_pc_err, uint32_t, producer,
+		    uint32_t, consumer);
 		mutex_exit(&instance->cmd_pend_mtx);
 		mutex_exit(&instance->completed_pool_mtx);
 		return (DDI_INTR_CLAIMED);
@@ -2280,10 +2430,10 @@
 		cmd = instance->cmd_list[context];
 
 		if (cmd->sync_cmd == MRSAS_TRUE) {
-		hdr = (struct mrsas_header *)&cmd->frame->hdr;
-		if (hdr) {
-			mlist_del_init(&cmd->list);
-		}
+			hdr = (struct mrsas_header *)&cmd->frame->hdr;
+			if (hdr) {
+				mlist_del_init(&cmd->list);
+			}
 		} else {
 			pkt = cmd->pkt;
 			if (pkt) {
@@ -2330,9 +2480,9 @@
 
 /*
  * ************************************************************************** *
- *                                                                            *
- *                                  libraries                                 *
- *                                                                            *
+ *									      *
+ *				    libraries				      *
+ *									      *
  * ************************************************************************** *
  */
 /*
@@ -2348,11 +2498,10 @@
 static struct mrsas_cmd *
 get_mfi_pkt(struct mrsas_instance *instance)
 {
-	mlist_t 		*head = &instance->cmd_pool_list;
+	mlist_t			*head = &instance->cmd_pool_list;
 	struct mrsas_cmd	*cmd = NULL;
 
 	mutex_enter(&instance->cmd_pool_mtx);
-	ASSERT(mutex_owned(&instance->cmd_pool_mtx));
 
 	if (!mlist_empty(head)) {
 		cmd = mlist_entry(head->next, struct mrsas_cmd, list);
@@ -2376,13 +2525,12 @@
 	struct mrsas_cmd	*cmd = NULL;
 
 	mutex_enter(&instance->app_cmd_pool_mtx);
-	ASSERT(mutex_owned(&instance->app_cmd_pool_mtx));
 
 	if (!mlist_empty(head)) {
 		cmd = mlist_entry(head->next, struct mrsas_cmd, list);
 		mlist_del_init(head->next);
 	}
-	if (cmd != NULL){
+	if (cmd != NULL) {
 		cmd->pkt = NULL;
 		cmd->retry_count_for_ocr = 0;
 		cmd->drv_pkt_time = 0;
@@ -2399,8 +2547,7 @@
 return_mfi_pkt(struct mrsas_instance *instance, struct mrsas_cmd *cmd)
 {
 	mutex_enter(&instance->cmd_pool_mtx);
-	ASSERT(mutex_owned(&instance->cmd_pool_mtx));
-
+	/* use mlist_add_tail for debug assistance */
 	mlist_add_tail(&cmd->list, &instance->cmd_pool_list);
 
 	mutex_exit(&instance->cmd_pool_mtx);
@@ -2410,7 +2557,6 @@
 return_mfi_app_pkt(struct mrsas_instance *instance, struct mrsas_cmd *cmd)
 {
 	mutex_enter(&instance->app_cmd_pool_mtx);
-	ASSERT(mutex_owned(&instance->app_cmd_pool_mtx));
 
 	mlist_add(&cmd->list, &instance->app_cmd_pool_list);
 
@@ -2423,8 +2569,7 @@
 	struct mrsas_header	*hdr;
 	con_log(CL_DLEVEL2, (CE_NOTE, "push_pending_pkt(): Called\n"));
 	mutex_enter(&instance->cmd_pend_mtx);
-	ASSERT(mutex_owned(&instance->cmd_pend_mtx));
-	mlist_del_init(&cmd->list);  
+	mlist_del_init(&cmd->list);
 	mlist_add_tail(&cmd->list, &instance->cmd_pend_list);
 	if (cmd->sync_cmd == MRSAS_TRUE) {
 		hdr = (struct mrsas_header *)&cmd->frame->hdr;
@@ -2435,15 +2580,15 @@
 			    "time %llx",
 			    (void *)cmd, cmd->index,
 			    gethrtime()));
-			/* Wait for specified interval  */
+			/* Wait for specified interval	*/
 			cmd->drv_pkt_time = ddi_get16(
 			    cmd->frame_dma_obj.acc_handle, &hdr->timeout);
 			if (cmd->drv_pkt_time < debug_timeout_g)
 				cmd->drv_pkt_time = (uint16_t)debug_timeout_g;
 				con_log(CL_ANN1, (CE_CONT,
-					"push_pending_pkt(): "
-					"Called IO Timeout Value %x\n",
-					cmd->drv_pkt_time));
+				    "push_pending_pkt(): "
+				    "Called IO Timeout Value %x\n",
+				    cmd->drv_pkt_time));
 		}
 		if (hdr && instance->timeout_id == (timeout_id_t)-1) {
 			instance->timeout_id = timeout(io_timeout_checker,
@@ -2467,7 +2612,7 @@
 	}
 
 	mutex_exit(&instance->cmd_pend_mtx);
-	
+
 }
 
 int
@@ -2482,7 +2627,6 @@
 	int saved_level;
 	int cmd_count = 0;
 
-
 	saved_level = debug_level_g;
 	debug_level_g = CL_ANN1;
 
@@ -2494,7 +2638,8 @@
 		if (tmp == head) {
 			mutex_exit(&instance->cmd_pend_mtx);
 			flag = 0;
-			con_log(CL_ANN1, (CE_CONT, "mrsas_print_pending_cmds(): NO MORE CMDS PENDING....\n"));
+			con_log(CL_ANN1, (CE_CONT, "mrsas_print_pending_cmds():"
+			    " NO MORE CMDS PENDING....\n"));
 			break;
 		} else {
 			cmd = mlist_entry(tmp, struct mrsas_cmd, list);
@@ -2501,25 +2646,35 @@
 			mutex_exit(&instance->cmd_pend_mtx);
 			if (cmd) {
 				if (cmd->sync_cmd == MRSAS_TRUE) {
-				hdr = (struct mrsas_header *)&cmd->frame->hdr;
+					hdr = (struct mrsas_header *)
+					    &cmd->frame->hdr;
 					if (hdr) {
-					con_log(CL_ANN1, (CE_CONT,
-					    "print: cmd %p index 0x%x drv_pkt_time 0x%x (NO-PKT) hdr %p\n",
-					    (void *)cmd, cmd->index, cmd->drv_pkt_time, (void *)hdr));
+						con_log(CL_ANN1, (CE_CONT,
+						    "print: cmd %p index 0x%x "
+						    "drv_pkt_time 0x%x (NO-PKT)"
+						    " hdr %p\n", (void *)cmd,
+						    cmd->index,
+						    cmd->drv_pkt_time,
+						    (void *)hdr));
 					}
 				} else {
 					pkt = cmd->pkt;
 					if (pkt) {
 					con_log(CL_ANN1, (CE_CONT,
-					    "print: cmd %p index 0x%x drv_pkt_time 0x%x pkt %p \n",
-					    (void *)cmd, cmd->index,  cmd->drv_pkt_time, (void *)pkt));
+					    "print: cmd %p index 0x%x "
+					    "drv_pkt_time 0x%x pkt %p \n",
+					    (void *)cmd, cmd->index,
+					    cmd->drv_pkt_time, (void *)pkt));
 					}
 				}
 
-				if (++cmd_count == 1)
-					mrsas_print_cmd_details(instance, cmd, 0xDD);
-				else
-					mrsas_print_cmd_details(instance, cmd, 1);
+				if (++cmd_count == 1) {
+					mrsas_print_cmd_details(instance, cmd,
+					    0xDD);
+				} else {
+					mrsas_print_cmd_details(instance, cmd,
+					    1);
+				}
 
 			}
 		}
@@ -2526,7 +2681,7 @@
 	}
 	con_log(CL_ANN1, (CE_CONT, "mrsas_print_pending_cmds(): Done\n"));
 
-	
+
 	debug_level_g = saved_level;
 
 	return (DDI_SUCCESS);
@@ -2598,18 +2753,16 @@
 }
 
 void
-mrsas_print_cmd_details(struct mrsas_instance *instance, 
-					struct mrsas_cmd *cmd, int detail )
+mrsas_print_cmd_details(struct mrsas_instance *instance, struct mrsas_cmd *cmd,
+    int detail)
 {
 	struct scsi_pkt *pkt = cmd->pkt;
 	Mpi2RaidSCSIIORequest_t *scsi_io = cmd->scsi_io_request;
-	MPI2_SCSI_IO_VENDOR_UNIQUE *raidContext;
-	uint8_t *cdb_p;
-	char str[100], *strp;
-	int i, j, len;
+	int i;
 	int saved_level;
+	ddi_acc_handle_t acc_handle =
+	    instance->mpi2_frame_pool_dma_obj.acc_handle;
 
-
 	if (detail == 0xDD) {
 		saved_level = debug_level_g;
 		debug_level_g = CL_ANN1;
@@ -2617,55 +2770,56 @@
 
 
 	if (instance->tbolt) {
-		con_log(CL_ANN1, (CE_CONT, "print_cmd_details: cmd %p cmd->index 0x%x SMID 0x%x timer 0x%x sec\n",
-		         (void *)cmd, cmd->index, cmd->SMID, cmd->drv_pkt_time));
+		con_log(CL_ANN1, (CE_CONT, "print_cmd_details: cmd %p "
+		    "cmd->index 0x%x SMID 0x%x timer 0x%x sec\n",
+		    (void *)cmd, cmd->index, cmd->SMID, cmd->drv_pkt_time));
+	} else {
+		con_log(CL_ANN1, (CE_CONT, "print_cmd_details: cmd %p "
+		    "cmd->index 0x%x timer 0x%x sec\n",
+		    (void *)cmd, cmd->index, cmd->drv_pkt_time));
 	}
-	else {
-		con_log(CL_ANN1, (CE_CONT, "print_cmd_details: cmd %p cmd->index 0x%x timer 0x%x sec\n",
-		         (void *)cmd, cmd->index, cmd->drv_pkt_time));
-	}
 
-	if(pkt) {
+	if (pkt) {
 		con_log(CL_ANN1, (CE_CONT, "scsi_pkt CDB[0]=0x%x",
-	              pkt->pkt_cdbp[0]));
-	}else {
+		    pkt->pkt_cdbp[0]));
+	} else {
 		con_log(CL_ANN1, (CE_CONT, "NO-PKT"));
 	}
 
-	if((detail==0xDD) && instance->tbolt) {
+	if ((detail == 0xDD) && instance->tbolt) {
 		con_log(CL_ANN1, (CE_CONT, "RAID_SCSI_IO_REQUEST\n"));
-		con_log(CL_ANN1, (CE_CONT, "DevHandle=0x%X Function=0x%X IoFlags=0x%X SGLFlags=0x%X DataLength=0x%X\n",
-			ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->DevHandle),
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->Function),
-			ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->IoFlags),
-			ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->SGLFlags),
-			ddi_get32(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->DataLength) ));
+		con_log(CL_ANN1, (CE_CONT, "DevHandle=0x%X Function=0x%X "
+		    "IoFlags=0x%X SGLFlags=0x%X DataLength=0x%X\n",
+		    ddi_get16(acc_handle, &scsi_io->DevHandle),
+		    ddi_get8(acc_handle, &scsi_io->Function),
+		    ddi_get16(acc_handle, &scsi_io->IoFlags),
+		    ddi_get16(acc_handle, &scsi_io->SGLFlags),
+		    ddi_get32(acc_handle, &scsi_io->DataLength)));
 
-		for(i=0; i < 32; i++)
-			con_log(CL_ANN1, (CE_CONT, "CDB[%d]=0x%x ",i,
-				ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->CDB.CDB32[i]) ));
+		for (i = 0; i < 32; i++) {
+			con_log(CL_ANN1, (CE_CONT, "CDB[%d]=0x%x ", i,
+			    ddi_get8(acc_handle, &scsi_io->CDB.CDB32[i])));
+		}
 
 		con_log(CL_ANN1, (CE_CONT, "RAID-CONTEXT\n"));
-		con_log(CL_ANN1, (CE_CONT, "status=0x%X extStatus=0x%X ldTargetId=0x%X timeoutValue=0x%X"
-			"regLockFlags=0x%X RAIDFlags=0x%X regLockRowLBA=0x%lX regLockLength=0x%X spanArm=0x%X\n",
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.status),
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.extStatus),
-			ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.ldTargetId),
-			ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.timeoutValue),
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.regLockFlags),
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.RAIDFlags),
-			ddi_get64(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.regLockRowLBA),
-			ddi_get32(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.regLockLength),
-			ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_io->RaidContext.spanArm) ));
-
-
+		con_log(CL_ANN1, (CE_CONT, "status=0x%X extStatus=0x%X "
+		    "ldTargetId=0x%X timeoutValue=0x%X regLockFlags=0x%X "
+		    "RAIDFlags=0x%X regLockRowLBA=0x%" PRIu64
+		    " regLockLength=0x%X spanArm=0x%X\n",
+		    ddi_get8(acc_handle, &scsi_io->RaidContext.status),
+		    ddi_get8(acc_handle, &scsi_io->RaidContext.extStatus),
+		    ddi_get16(acc_handle, &scsi_io->RaidContext.ldTargetId),
+		    ddi_get16(acc_handle, &scsi_io->RaidContext.timeoutValue),
+		    ddi_get8(acc_handle, &scsi_io->RaidContext.regLockFlags),
+		    ddi_get8(acc_handle, &scsi_io->RaidContext.RAIDFlags),
+		    ddi_get64(acc_handle, &scsi_io->RaidContext.regLockRowLBA),
+		    ddi_get32(acc_handle, &scsi_io->RaidContext.regLockLength),
+		    ddi_get8(acc_handle, &scsi_io->RaidContext.spanArm)));
 	}
 
 	if (detail == 0xDD) {
 		debug_level_g = saved_level;
 	}
-
-	return;
 }
 
 
@@ -2687,10 +2841,11 @@
 			con_log(CL_ANN1, (CE_CONT,
 			    "mrsas_issue_pending_cmds(): "
 			    "Got a cmd: cmd %p index 0x%x drv_pkt_time 0x%x ",
-					    (void *)cmd, cmd->index, cmd->drv_pkt_time));
+			    (void *)cmd, cmd->index, cmd->drv_pkt_time));
 
+			/* Reset command timeout value */
 			if (cmd->drv_pkt_time < debug_timeout_g)
-				cmd->drv_pkt_time = (uint16_t)debug_timeout_g;	/* Reset command timeout value */
+				cmd->drv_pkt_time = (uint16_t)debug_timeout_g;
 
 			cmd->retry_count_for_ocr++;
 
@@ -2698,16 +2853,16 @@
 			    cmd->retry_count_for_ocr);
 
 			if (cmd->retry_count_for_ocr > IO_RETRY_COUNT) {
-				cmn_err(CE_WARN,
-					"mrsas_issue_pending_cmds(): cmd->retry_count exceeded limit >%d\n",
+				cmn_err(CE_WARN, "mrsas_issue_pending_cmds(): "
+				    "cmd->retry_count exceeded limit >%d\n",
 				    IO_RETRY_COUNT);
 				mrsas_print_cmd_details(instance, cmd, 0xDD);
 
 				cmn_err(CE_WARN,
-					"mrsas_issue_pending_cmds():"
+				    "mrsas_issue_pending_cmds():"
 				    "Calling KILL Adapter\n");
 				if (instance->tbolt)
-					(void) mrsas_tbolt_kill_adapter(instance);
+					mrsas_tbolt_kill_adapter(instance);
 				else
 					(void) mrsas_kill_adapter(instance);
 				return (DDI_FAILURE);
@@ -2724,16 +2879,17 @@
 
 			} else {
 				cmn_err(CE_CONT,
-					"mrsas_issue_pending_cmds(): "
-					"NO-PKT, cmd %p index 0x%x drv_pkt_time 0x%x ",
-					    (void *)cmd, cmd->index, cmd->drv_pkt_time);
+				    "mrsas_issue_pending_cmds(): NO-PKT, "
+				    "cmd %p index 0x%x drv_pkt_time 0x%x ",
+				    (void *)cmd, cmd->index, cmd->drv_pkt_time);
 			}
 
 
 			if (cmd->sync_cmd == MRSAS_TRUE) {
-				cmn_err(CE_CONT, "mrsas_issue_pending_cmds(): SYNC_CMD == TRUE \n");
-
-				instance->func_ptr->issue_cmd_in_sync_mode(instance, cmd);
+				cmn_err(CE_CONT, "mrsas_issue_pending_cmds(): "
+				    "SYNC_CMD == TRUE \n");
+				instance->func_ptr->issue_cmd_in_sync_mode(
+				    instance, cmd);
 			} else {
 				instance->func_ptr->issue_cmd(cmd, instance);
 			}
@@ -2842,7 +2998,7 @@
 		}
 
 		ddi_put32(cmd->frame_dma_obj.acc_handle,
-				&cmd->frame->io.context, cmd->index);
+		    &cmd->frame->io.context, cmd->index);
 		i++;
 
 		con_log(CL_DLEVEL3, (CE_NOTE, "[%x]-%x",
@@ -2853,7 +3009,7 @@
 
 mrsas_undo_frame_pool:
 	if (i > 0)
-	  destroy_mfi_frame_pool(instance);
+		destroy_mfi_frame_pool(instance);
 
 	return (retval);
 }
@@ -2973,8 +3129,10 @@
 
 	/* First free each cmd */
 	for (i = 0; i < max_cmd; i++) {
-		if (instance->cmd_list[i] != NULL)
-			kmem_free(instance->cmd_list[i],sizeof (struct mrsas_cmd));
+		if (instance->cmd_list[i] != NULL) {
+			kmem_free(instance->cmd_list[i],
+			    sizeof (struct mrsas_cmd));
+		}
 
 		instance->cmd_list[i] = NULL;
 	}
@@ -2981,7 +3139,7 @@
 
 	/* Now, free cmd_list array */
 	if (instance->cmd_list != NULL)
-		kmem_free(instance->cmd_list,sz);
+		kmem_free(instance->cmd_list, sz);
 
 	instance->cmd_list = NULL;
 
@@ -2989,8 +3147,7 @@
 	INIT_LIST_HEAD(&instance->cmd_pend_list);
 	if (instance->tbolt) {
 		INIT_LIST_HEAD(&instance->cmd_app_pool_list);
-	}
-	else {
+	} else {
 		INIT_LIST_HEAD(&instance->app_cmd_pool_list);
 	}
 
@@ -3024,21 +3181,13 @@
 	 * commands.
 	 */
 	instance->cmd_list = kmem_zalloc(sz, KM_SLEEP);
-	if (instance->cmd_list == NULL) {
-		con_log(CL_NONE, (CE_WARN,
-		    "Failed to allocate memory for cmd_list"));
-		return (DDI_FAILURE);
-	}
+	ASSERT(instance->cmd_list);
 
 	/* create a frame pool and assign one frame to each cmd */
 	for (count = 0; count < max_cmd; count++) {
-		instance->cmd_list[count] = kmem_zalloc(sizeof (struct mrsas_cmd),
-		    KM_SLEEP);
-		if (instance->cmd_list[count] == NULL) {
-			con_log(CL_NONE, (CE_WARN,
-				"Failed to allocate memory for mrsas_cmd"));
-			goto mrsas_undo_cmds;
-		}
+		instance->cmd_list[count] =
+		    kmem_zalloc(sizeof (struct mrsas_cmd), KM_SLEEP);
+		ASSERT(instance->cmd_list[count]);
 	}
 
 	/* add all the commands to command pool */
@@ -3047,18 +3196,18 @@
 	INIT_LIST_HEAD(&instance->cmd_pend_list);
 	INIT_LIST_HEAD(&instance->app_cmd_pool_list);
 
-	reserve_cmd	= MRSAS_APP_RESERVED_CMDS;
+	reserve_cmd = MRSAS_APP_RESERVED_CMDS;
 
-	for (i = 0; i < reserve_cmd; i++) {  
-		cmd		= instance->cmd_list[i];
-		cmd->index	= i;
+	for (i = 0; i < reserve_cmd; i++) {
+		cmd = instance->cmd_list[i];
+		cmd->index = i;
 		mlist_add_tail(&cmd->list, &instance->app_cmd_pool_list);
 	}
-	
 
+
 	for (i = reserve_cmd; i < max_cmd; i++) {
-		cmd		= instance->cmd_list[i];
-		cmd->index	= i;
+		cmd = instance->cmd_list[i];
+		cmd->index = i;
 		mlist_add_tail(&cmd->list, &instance->cmd_pool_list);
 	}
 
@@ -3068,8 +3217,10 @@
 	if (count > 0) {
 		/* free each cmd */
 		for (i = 0; i < count; i++) {
-			if (instance->cmd_list[i] != NULL)
-				kmem_free(instance->cmd_list[i],sizeof (struct mrsas_cmd));
+			if (instance->cmd_list[i] != NULL) {
+				kmem_free(instance->cmd_list[i],
+				    sizeof (struct mrsas_cmd));
+			}
 			instance->cmd_list[i] = NULL;
 		}
 	}
@@ -3076,7 +3227,7 @@
 
 mrsas_undo_cmd_list:
 	if (instance->cmd_list != NULL)
-		kmem_free(instance->cmd_list,sz);
+		kmem_free(instance->cmd_list, sz);
 	instance->cmd_list = NULL;
 
 	return (DDI_FAILURE);
@@ -3112,10 +3263,10 @@
 static int
 alloc_space_for_mfi(struct mrsas_instance *instance)
 {
-	/* Allocate command pool ( memory for cmd_list & individual commands )*/
+	/* Allocate command pool (memory for cmd_list & individual commands) */
 	if (mrsas_alloc_cmd_pool(instance)) {
 		cmn_err(CE_WARN, "error creating cmd pool");
-		return (DDI_FAILURE); 
+		return (DDI_FAILURE);
 	}
 
 	/* Allocate MFI Frame pool */
@@ -3156,17 +3307,17 @@
 	struct mrsas_dcmd_frame	*dcmd;
 	struct mrsas_ctrl_info	*ci;
 
-	if(instance->tbolt) {
+	if (instance->tbolt) {
 		cmd = get_raid_msg_mfi_pkt(instance);
-	}
-	else {
+	} else {
 		cmd = get_mfi_pkt(instance);
 	}
 
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in get_ctrl_info(). fw_outstanding=0x%X max_fw_cmds=0x%X",
-				instance->fw_outstanding, instance->max_fw_cmds);
+		con_log(CL_ANN, (CE_WARN,
+		    "Failed to get a cmd for ctrl info"));
+		DTRACE_PROBE2(info_mfi_err, uint16_t, instance->fw_outstanding,
+		    uint16_t, instance->max_fw_cmds);
 		return (DDI_FAILURE);
 	}
 
@@ -3210,38 +3361,40 @@
 	cmd->frame_count = 1;
 
 	if (instance->tbolt) {
-    	mr_sas_tbolt_build_mfi_cmd(instance, cmd);
-    }
-	
+		mr_sas_tbolt_build_mfi_cmd(instance, cmd);
+	}
+
 	if (!instance->func_ptr->issue_cmd_in_poll_mode(instance, cmd)) {
-	ret = 0;
+		ret = 0;
 
-	ctrl_info->max_request_size = ddi_get32(
-	    cmd->frame_dma_obj.acc_handle, &ci->max_request_size);
+		ctrl_info->max_request_size = ddi_get32(
+		    cmd->frame_dma_obj.acc_handle, &ci->max_request_size);
 
-	ctrl_info->ld_present_count = ddi_get16(
-	    cmd->frame_dma_obj.acc_handle, &ci->ld_present_count);
+		ctrl_info->ld_present_count = ddi_get16(
+		    cmd->frame_dma_obj.acc_handle, &ci->ld_present_count);
 
-	ctrl_info->properties.on_off_properties =
-	    ddi_get32(cmd->frame_dma_obj.acc_handle,
-	    &ci->properties.on_off_properties);
-	ddi_rep_get8(cmd->frame_dma_obj.acc_handle,
-	    (uint8_t *)(ctrl_info->product_name),
-	    (uint8_t *)(ci->product_name), 80 * sizeof (char),
-	    DDI_DEV_AUTOINCR);
-	/* should get more members of ci with ddi_get when needed */
+		ctrl_info->properties.on_off_properties = ddi_get32(
+		    cmd->frame_dma_obj.acc_handle,
+		    &ci->properties.on_off_properties);
+		ddi_rep_get8(cmd->frame_dma_obj.acc_handle,
+		    (uint8_t *)(ctrl_info->product_name),
+		    (uint8_t *)(ci->product_name), 80 * sizeof (char),
+		    DDI_DEV_AUTOINCR);
+		/* should get more members of ci with ddi_get when needed */
 	} else {
 		cmn_err(CE_WARN, "get_ctrl_info: Ctrl info failed");
 		ret = -1;
 	}
 
-	if(instance->tbolt) {
-		return_raid_msg_mfi_pkt(instance, cmd);
+	if (mrsas_common_check(instance, cmd) != DDI_SUCCESS) {
+		ret = -1;
 	}
-	else {
+	if (instance->tbolt) {
+		return_raid_msg_mfi_pkt(instance, cmd);
+	} else {
 		return_mfi_pkt(instance, cmd);
 	}
-	
+
 	return (ret);
 }
 
